#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

Rmpfi_set_default_prec(16);

sub f {
  my $x = shift;
  return ((((-7/3*$x+35/2)*$x-136/3)*$x+93/2)*$x-46/3)*$x+1;
}

my $x = Math::MPFI->new('[0,3]');
my $x1 = Math::MPFI->new();
my $x2 = Math::MPFI->new();

Rmpfi_bisect ($x1, $x2, $x);
my $y1 = f($x1);
my $y2 = f($x2);
my $y = Math::MPFI->new();
Rmpfi_union($y, $y1, $y2);

print "f(x)              = ", f($x), "\n";
print "f(x1) union f(x2) = $y\n";
