#!/usr/bin/perl
use strict;
use warnings;
use Math::MPFI qw(:mpfi);

Rmpfi_set_default_prec(32);

sub f {
  my $x = shift;
  return ((((-7/3*$x+35/2)*$x-136/3)*$x+93/2)*$x-46/3)*$x+1;
}

my $x = Math::MPFI->new('[0,3]');

sub Refine{                                 # refinement routine
  my ($ref, $x, $n) = @_;
  my $y = Math::MPFI->new();
  
  if ($n == 0) {
    $y = $ref->($x);
  }
  else {
    my $x1 = Math::MPFI->new();
    my $x2 = Math::MPFI->new();
    Rmpfi_bisect ($x1, $x2, $x);
    my $y1 = Refine($ref, $x1, $n-1);
    my $y2 = Refine($ref, $x2, $n-1);
    Rmpfi_union($y, $y1, $y2);
  }
  return $y;
}
    
for ( 0..18) {
  print 2**$_, "\t\t", Refine(\&f, $x, $_), "\n";
}
